#include "tablero.h"




// Funci�n para poner trampas en base a un nivel
void Tablero::putTrampas(int nivel){
    int iniRand = 1;
	int finRand = 16 - nivel;
	int valor = 0;
	if(finRand < 8) finRand = 8;
	for (int i = 0; i < K_FILA; i++) {
        for (int j = 0; j < K_COLUMNA; j++) {
            valor = iniRand + rand()%finRand;
            if (valor != 1) valor=0;
            this->tablero_juego[i][j].putTrampaCasilla(valor);
        }
    }
}

// Funci�n que vac�a el tablero
void Tablero::inicializa_tablero() {
    for (int i = 0; i < K_FILA; i++) {
        for (int j = 0; j < K_COLUMNA; j++) {
            this->tablero_juego[i][j].putTrampaCasilla(false);
            this->tablero_juego[i][j].putPisadaCasilla(false);
            this->tablero_juego[i][j].putJugadorCasilla(false);
            this->tablero_juego[i][j].putMarcaCasilla(false);
            this->tablero_juego[i][j].putX(i);
            this->tablero_juego[i][j].putY(j);
        }
    } 
}

// Funci�n que devuelve una Casilla del Tablero
Casilla & Tablero::getCasilla(int i, int j) {
    return tablero_juego[i][j];                        
}

// Visualizar el Tablero en el centro de la pantalla
string Tablero::visualizarTablero(char avatar) {
      string tablero = ""; 
      for (int i = 0; i < K_FILA; i++) {
        for (int j = 0; j < K_COLUMNA; j++) {
            if ((tablero_juego[i][j].getPisadaCasilla() == true)&&(tablero_juego[i][j].getJugadorCasilla() == false)) tablero+="*";
            else if (tablero_juego[i][j].getJugadorCasilla() == true) tablero+="ô";
            else tablero+="-";
        }
        tablero+="\n";
      }
      return tablero;
}

// Funci�n que devuelve la casilla en la que est� el Jugador
Casilla & Tablero::getCasillaJugador() {
   
        bool encontrado = false;
        int fila = 0;
        int columna = 0;
        for (fila=0; ((fila < K_FILA)&&(!encontrado)); fila++) {
            for (columna=0; ((columna < K_COLUMNA)&&(!encontrado)); columna++) {

               if (tablero_juego[fila][columna].getJugadorCasilla()) encontrado = true;
            }
        }
        if (encontrado) return this->getCasilla(fila-1, columna-1);
}

// Visualizar trampas del Tablero en el centro de la pantalla
string Tablero::visualizarTrampasTablero(char avatar) {
      string tablero_trampas = ""; 
      // Visualizar trampas
      for (int i = 0; i < K_FILA; i++) {
        for (int j = 0; j < K_COLUMNA; j++) {
            if ((tablero_juego[i][j].getTrampaCasilla() == true)&&(tablero_juego[i][j].getJugadorCasilla() == false)) tablero_trampas+="X";
            else if ((tablero_juego[i][j].getPisadaCasilla() == true)&&(tablero_juego[i][j].getJugadorCasilla() == false)) tablero_trampas+="*";
            else if (tablero_juego[i][j].getJugadorCasilla() == true) tablero_trampas+="ô";
            else tablero_trampas+="-";
        }
        tablero_trampas+="\n";
      }
      return tablero_trampas;
}

// Funci�n que muestra las trampas que hay alrededor de una casilla
int Tablero::getTrampasCercanas(Casilla casilla) {
     int norte = 0;
     int sur = 0;
     int este = 0;
     int oeste = 0;
     bool up = false;
     bool down = false;
     bool right = false;
     bool left = false;

     
     if (casilla.getX() > 0) {
        norte = casilla.getX()-1;
        if (tablero_juego[norte][casilla.getY()].getTrampaCasilla() == true) up = true;
     }
     
     if (casilla.getX() < K_FILA-1) {
        sur = casilla.getX()+1;
        if (tablero_juego[sur][casilla.getY()].getTrampaCasilla() == true) down = true;
     }
     
     if (casilla.getY() < K_COLUMNA-1) {
        este = casilla.getY()+1;
        if (tablero_juego[casilla.getX()][este].getTrampaCasilla() == true) right = true;
     }
     
     if (casilla.getY() > 0) {
        oeste = casilla.getY()-1;
        if (tablero_juego[casilla.getX()][oeste].getTrampaCasilla() == true) left = true;
     }
        
     
     return up + down + left + right;
}

